diff -ruN asterisk-1.4.17/apps/app_dial.c asterisk-1.4.17-excel/apps/app_dial.c
--- asterisk-1.4.17/apps/app_dial.c	2007-12-07 10:38:48.000000000 -0600
+++ asterisk-1.4.17-excel/apps/app_dial.c	2008-01-03 10:38:19.000000000 -0600
@@ -1198,6 +1198,9 @@
 
 				pbx_builtin_setvar_helper(tmp->chan, "DIALEDPEERNUMBER", numsubst);
 
+		/* Tell the new B-leg channel that we're the A-leg */
+		tmp->chan->bridge_channel = chan;
+
 		/* Setup outgoing SDP to match incoming one */
 		ast_rtp_make_compatible(tmp->chan, chan, !outgoing && !rest);
diff -ruN asterisk-1.4.17/channels/chan_sip.c asterisk-1.4.17-excel/channels/chan_sip.c
--- asterisk-1.4.17/channels/chan_sip.c	2008-01-02 14:24:09.000000000 -0600
+++ asterisk-1.4.17-excel/channels/chan_sip.c	2008-01-03 10:36:41.000000000 -0600
@@ -2990,6 +2997,13 @@
 	if (option_debug)
 		ast_log(LOG_DEBUG, "Outgoing Call for %s\n", p->username);
 
+	
+	/* tell the A-leg the call id */
+	if(ast->bridge_channel) {
+		ast_log(LOG_DEBUG, "Setting DIALEDCALLID variable to %s\n", p->callid);
+		pbx_builtin_setvar_helper(ast->bridge_channel, "DIALEDCALLID", p->callid);
+	}
+	
 	res = update_call_counter(p, INC_CALL_RINGING);
 	if ( res != -1 ) {
 		p->callingpres = ast->cid.cid_pres;
diff -ruN asterisk-1.4.17/include/asterisk/channel.h asterisk-1.4.17-excel/include/asterisk/channel.h
--- asterisk-1.4.17/include/asterisk/channel.h	2007-12-03 17:12:17.000000000 -0600
+++ asterisk-1.4.17-excel/include/asterisk/channel.h	2008-01-03 10:36:41.000000000 -0600
@@ -341,6 +344,9 @@
 		AST_STRING_FIELD(accountcode);		/*!< Account code for billing */
 		AST_STRING_FIELD(call_forward);		/*!< Where to forward to if asked to dial on this interface */
 		AST_STRING_FIELD(uniqueid);		/*!< Unique Channel Identifier */
+
+	/*! \brief For bridge B-leg channels, bridge_channel is the pointer to the A-leg, null otherwise */
+	struct ast_channel *bridge_channel;
 	);
 	
 	/*! \brief File descriptor for channel -- Drivers will poll on these file descriptors, so at least one must be non -1.  */
diff -ruN asterisk-1.4.17/main/channel.c asterisk-1.4.17-excel/main/channel.c
--- asterisk-1.4.17/main/channel.c	2007-12-27 15:40:02.000000000 -0600
+++ asterisk-1.4.17-excel/main/channel.c	2008-01-03 10:36:41.000000000 -0600
@@ -3273,6 +3273,9 @@
 		
 		if (!(c = chan->tech->requester(type, capabilities | videoformat, data, cause)))
 			return NULL;
+			
+		/* default to assumption that this is not a bridge B-leg channel */
+		c->bridge_channel = NULL;
 
 		/* no need to generate a Newchannel event here; it is done in the channel_alloc call */
 		return c;
